%token NONE SCDECL XSCDECL SECTEND BOL
%token LBRACE RBRACE EOL EOF_OP EOF_TOK FALLTHRU_ACT ASSIGN_ACT FOLLOWED_BY ALTERNATIVE STAR 
%token PLUS OPT DOT LPAREN RPAREN NOT CCE_ALNUM CCE_ALPHA CCE_BLANK 
%token CCE_CNTRL CCE_DIGIT CCE_GRAPH CCE_LOWER CCE_PRINT CCE_PUNCT CCE_SPACE 
%token CCE_UPPER CCE_XDIGIT LBRACK 
%token RBRACK LANGLE RANGLE TOKENS COUNTERS SYMTBLS NL DASH WS TOKEN_ACT 
%token TOKENTEXT_ACT IF_ACT THEN_ACT ELSE_ACT PUSH_ACT POP_ACT BEGIN_ACT 
%token START_ACT END_ACT ECHO_ACT SKIP_ACT ERROR_ACT INCR_ACT DECR_ACT
%token ADD_ACT REMOVE_ACT 
%token CONTINUE_ACT CUT_ACT TRIM_ACT SEMI COMMA EQUALS NEQUALS LT LTE GT GTE
%token MEM
%token <xml_string> ID ABBREV_ID ESCAPE CHAR NUMBER REF QUOTED STRING

%{
#include "xmlbase.h"
%}

%union {
  xml_content_t* xml_content;
  xml_element_t* xml_element;
  xml_attribute_t* xml_attribute;
  xml_list_t* xml_list;
  char* xml_string;
}

%type <xml_content> goal flexrule rule re re2 singleton fullccl char_or_escape
%type <xml_content> exp sconname test action act
%type <xml_string> ccl_expr
%type <xml_list> sect1 sect2 namelist1 namelist2 namelist3 namelist4 namelist5
%type <xml_list> scon series
%type <xml_list> ccl action_seq block_action
%%

goal : sect1 SECTEND sect2 EOF_TOK         {$$ = ELEMENT("xlex",CONS(ELEMENT("declarations",REV($1)),CONS(ELEMENT("rules",REV($3)),NIL)));
                                            fprint_xml_content(stdout,$$);
                                            YYACCEPT;}
     ;

sect1 : sect1 SCDECL namelist1 NL  {$$ = CONS(ELEMENT("inclusive_states",REV($3)),$1);}
      | sect1 XSCDECL namelist1 NL {$$ = CONS(ELEMENT("exclusive_states",REV($3)),$1);}
      | sect1 ABBREV_ID WS re NL   {$$ = CONS(ELEMENT("abbreviation",CONS(ELEMENT("id",SINGL(TEXT($2))),CONS(ELEMENT("regexp",SINGL($4)),NIL))),$1);}
      | sect1 TOKENS namelist3 NL  {$$ = CONS(ELEMENT("token_declaration",REV($3)),$1);}
      | sect1 COUNTERS namelist4 NL  {$$ = CONS(ELEMENT("counter_declaration",REV($3)),$1);}
      | sect1 SYMTBLS namelist5 NL  {$$ = CONS(ELEMENT("symtbl_declaration",REV($3)),$1);}
      | sect1 NL                   {$$ = $1;}
      |                            {$$ = NIL;}
      | error                      {ERROR("expecting section 1 declaration");}
      ;

namelist1 : namelist1 ID           {$$ = CONS (ELEMENT("state_id",SINGL(TEXT($2))),$1);}
          | ID                     {$$ = SINGL(ELEMENT("state_id",SINGL(TEXT($1))));}
          | error                  {ERROR("expecting state name list");}
          ;
namelist3 : namelist3 ID           {$$ = CONS (ELEMENT("token_id",SINGL(TEXT($2))),$1);}
          | ID                     {$$ = SINGL(ELEMENT("token_id",SINGL(TEXT($1))));}
          | error                  {ERROR("expecting token name list");}
          ;

namelist4 : namelist4 ID           {$$ = CONS (ELEMENT("counter_id",SINGL(TEXT($2))),$1);}
          | ID                     {$$ = SINGL(ELEMENT("counter_id",SINGL(TEXT($1))));}
          | error                  {ERROR("expecting counter name list");}
          ;

namelist5 : namelist5 ID           {$$ = CONS (ELEMENT("symtbl_id",SINGL(TEXT($2))),$1);}
          | ID                     {$$ = SINGL(ELEMENT("symtbl_id",SINGL(TEXT($1))));}
          | error                  {ERROR("expecting symtbl name list");}
          ;

sect2 : sect2 scon flexrule NL     {if ($2 == NIL) {
                                      $$ = CONS(ELEMENT("rule",CONS(ELEMENT("xcon",$2),CONS(ELEMENT("regexp",SINGL($3)),NIL))),$1);
				    } else {
                                      $$ = CONS(ELEMENT("rule",CONS(ELEMENT("scon",$2),CONS(ELEMENT("regexp",SINGL($3)),NIL))),$1);
				    }
				   }

      | sect2 scon flexrule WS action NL 
                                   {if ($2 == NIL) {
				      $$ = CONS(ELEMENT("rule",CONS(ELEMENT("regexp",SINGL($3)),CONS(ELEMENT1("action",$5),NIL))),$1);
				    } else { 
    				      $$ = CONS(ELEMENT("rule",CONS(ELEMENT("scon",$2),CONS(ELEMENT("regexp",SINGL($3)),CONS(ELEMENT1("action",$5),NIL)))),$1);
				    }
				   }
      | sect2 scon LBRACE sect2 RBRACE NL
                                   {if($2 == NIL) {
				     $$ = CONS(ELEMENT("scope",REV($4)),$1);
				    } else {
				      $$ = CONS(ELEMENT("scope",CONS(ELEMENT("scon",$2),REV($4))),$1);
				    }
				   }
      | sect2 NL                   {$$ = $1;}
      |                            {$$ = NIL;}
      ;

flexrule : BOL rule                {$$ = ELEMENT("bol",SINGL($2));}
         | rule                    {$$ = $1;} 
         | EOF_OP                  {$$ = ELEMENT("eof",NIL);}
         | error                   {ERROR ("unrecognizable rule");}
         ;

scon : LANGLE namelist2 RANGLE     {$$ = REV($2);}
     | LANGLE STAR RANGLE          {$$ = CONS(ELEMENT("any_state",NIL),NIL);}
     |                             {$$ = NIL;}
     ;

namelist2 : namelist2 COMMA sconname 
                                   {$$ = CONS(ELEMENT("state_id",SINGL($3)),$1);}
          | sconname               {$$ = CONS(ELEMENT("state_id",SINGL($1)),NIL);}
          | error                  {ERROR ("expecting state name list");}
          ;

sconname : ID                      { $$ = TEXT($1);}
         ;

rule : re2 re                      {$$ = ELEMENT("followed_by",CONS( $1 ,CONS( $2 ,NIL)));}
     | re2 re EOL                  {$$ = ELEMENT("followed_by",CONS($1,CONS(ELEMENT("eol",CONS($2,NIL)),NIL)));}
     | re EOL                      {$$ = ELEMENT("eol",CONS($1,NIL));}
     | re                          {$$ = $1;}
     ;

re : re ALTERNATIVE series         {$$ = ELEMENT("alt",CONS($1,SINGL(ELEMENT("seq",REV($3)))));}
   | series                        {$$ = ELEMENT("seq",REV($1));}
   ;

re2 : re FOLLOWED_BY               {$$ = $1;}
    ;

series : series singleton          {$$ = CONS($2,$1);}
       | singleton                 {$$ = CONS($1,NIL);}
       ;

singleton : singleton STAR         {$$ = ELEMENT("star",SINGL($1));}
          | singleton PLUS         {$$ = ELEMENT("plus",SINGL($1));}
          | singleton OPT          {$$ = ELEMENT("opt",SINGL($1));}
	  | singleton LBRACE NUMBER COMMA NUMBER RBRACE
                                   {$$ = ELEMENT("pow",CONS($1,SINGL(ELEMENT("between",CONS(ELEMENT("num",SINGL(TEXT($3))),CONS(ELEMENT("num",SINGL(TEXT($5))),NIL))))));}
	  | singleton LBRACE NUMBER COMMA RBRACE
                                   {$$ = ELEMENT("pow",CONS($1,SINGL(ELEMENT("atleast",CONS(TEXT($3),NIL)))));}
	  | singleton LBRACE NUMBER RBRACE
                                   {$$ = ELEMENT("pow",CONS($1,SINGL(ELEMENT("exact",CONS(TEXT($3),NIL)))));}
          | REF                    {$$ = ELEMENT("ref",SINGL(ELEMENT("id",SINGL(TEXT($1)))));}
	  | DOT                    {$$ = ELEMENT("dot",NIL);}
          | fullccl                {$$ = $1;}
	  | QUOTED                 {$$ = ELEMENT("quot",SINGL(TEXT($1)));}
	  | LPAREN re RPAREN       {$$ = $2;}
	  | char_or_escape         {$$ = $1;}
	  ;

fullccl : LBRACK ccl RBRACK        {$$ = ELEMENT("class",REV($2));}
	| LBRACK NOT ccl RBRACK    {$$ = ELEMENTATTS("class",CONS(ATTRIBUTE("negated","true"),NIL),REV($3));}
	;

char_or_escape : CHAR              {$$ = ELEMENT("char",SINGL(TEXT($1)));}
               | ESCAPE            {$$ = ELEMENT("esc",SINGL(TEXT($1)));}
               ;

ccl : ccl char_or_escape DASH char_or_escape 
                                   {$$ = CONS(ELEMENT("range",CONS($2,CONS($4,NIL))),$1);}
    | ccl char_or_escape           {$$ = CONS($2,$1);}
    | ccl ccl_expr                 {$$ = CONS(ELEMENTATTS("expr",CONS(ATTRIBUTE("val",$2),NIL),NIL),$1);}
    |                              {$$ = NIL;}
    ;

ccl_expr : CCE_ALNUM               {$$ = "alnum";}
	 | CCE_ALPHA               {$$ = "alpha";}
	 | CCE_BLANK               {$$ = "blank";}
	 | CCE_CNTRL               {$$ = "cntrl";}
	 | CCE_DIGIT               {$$ = "digit";}
	 | CCE_GRAPH               {$$ = "graph";}
	 | CCE_LOWER               {$$ = "lower";}
	 | CCE_PRINT               {$$ = "punct";}
	 | CCE_PUNCT               {$$ = "punct";}
	 | CCE_SPACE               {$$ = "space";}
	 | CCE_UPPER               {$$ = "upper";}
	 | CCE_XDIGIT               {$$ = "xdigit";}
	 ;


exp : ID                           {$$ = ELEMENT1("counter_id",TEXT($1));}
    | NUMBER                       {$$ = ELEMENT1("num",TEXT($1));}
    ;

test : exp EQUALS exp              {$$ = ELEMENT2("equals",ELEMENT1("exp",$1),ELEMENT1("exp",$3));}
     | exp NEQUALS exp             {$$ = ELEMENT2("nequals",ELEMENT1("exp",$1),ELEMENT1("exp",$3));}
     | exp LT exp                  {$$ = ELEMENT2("lt",ELEMENT1("exp",$1),ELEMENT1("exp",$3));}
     | exp LTE exp                 {$$ = ELEMENT2("lte",ELEMENT1("exp",$1),ELEMENT1("exp",$3));}
     | exp GT exp                  {$$ = ELEMENT2("gt",ELEMENT1("exp",$1),ELEMENT1("exp",$3));}
     | exp GTE exp                 {$$ = ELEMENT2("gte",ELEMENT1("exp",$1),ELEMENT1("exp",$3));}
     | MEM LPAREN ID RPAREN { $$ = ELEMENT1("mem",ELEMENT1("symtbl_id",TEXT($3)));}
     ;
action : FALLTHRU_ACT              {$$ = ELEMENT("fallthru",NIL);}
       | action_seq                {$$ = ELEMENT("action_code",REV($1));}
       | block_action              {$$ = ELEMENT("action_code",$1);}
       ;

block_action : LBRACE action_seq RBRACE  {$$ = REV($2);}
       ;

action_seq :     {$$ = NIL;}
| action_seq act SEMI { $$ = CONS($2,$1);}
| action_seq IF_ACT LPAREN test RPAREN THEN_ACT block_action ELSE_ACT block_action
                                   {$$ = CONS(ELEMENT("if",CONS(ELEMENT("test",SINGL($4)),CONS(ELEMENT("then",$7),CONS(ELEMENT("else",$9),NIL)))),$1);}
;

act : ID ASSIGN_ACT NUMBER 
				   {$$ = ELEMENT2("assign",ELEMENT1("counter_id",TEXT($1)),ELEMENT1("num",TEXT($3)));}
       | BEGIN_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT("begin",SINGL(ELEMENT("state_id",SINGL(TEXT($3)))));}
       | PUSH_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT("push",SINGL(ELEMENT("state_id",SINGL(TEXT($3)))));}
       | POP_ACT 
                                   {$$ = ELEMENT("pop",NIL);}
       | INCR_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT1("incr",ELEMENT1("counter_id",TEXT($3)));}
       | DECR_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT1("decr",ELEMENT1("counter_id",TEXT($3)));}
       | ADD_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT1("add",ELEMENT1("symtbl_id",TEXT($3)));}
       | REMOVE_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT1("remove",ELEMENT1("symtbl_id",TEXT($3)));}
       | TOKEN_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT("token",SINGL(ELEMENT("token_id",SINGL(TEXT($3)))));}
       | TOKENTEXT_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT("tokentext",SINGL(ELEMENT("token_id",SINGL(TEXT($3)))));}
       | START_ACT LPAREN ID RPAREN 
                                   {$$ = ELEMENT("start",SINGL(ELEMENT("token_id",SINGL(TEXT($3)))));}
       | END_ACT 
                                   {$$ = ELEMENT("end",NIL);}
       | CONTINUE_ACT 
                                   {$$ = ELEMENT("continue",NIL);}
       | ERROR_ACT LPAREN STRING RPAREN 
                                   {$$ = ELEMENT("error",SINGL(TEXT($3)));}
       | SKIP_ACT 
                                   {$$ = ELEMENT("skip",NIL);}
       | CUT_ACT LPAREN NUMBER RPAREN 
            			   {$$ = ELEMENT1("cut",ELEMENT1("num",TEXT($3)));}
       | TRIM_ACT LPAREN NUMBER RPAREN 
            			   {$$ = ELEMENT1("trim",ELEMENT1("num",TEXT($3)));}
       | ECHO_ACT 
                                   {$$ = ELEMENT0("echo");}
       ;

/*
action_seq :  action_seq IF_ACT LPAREN test RPAREN THEN_ACT block_action ELSE_ACT block_action
                                   {$$ = CONS(ELEMENT("if",CONS(ELEMENT("test",SINGL($4)),CONS(ELEMENT("then",$7),CONS(ELEMENT("else",$9),NIL)))),$1);}
       | action_seq ID ASSIGN_ACT NUMBER SEMI
				   {$$ = CONS(ELEMENT2("assign",ELEMENT1("counter_id",TEXT($2)),ELEMENT1("num",TEXT($4))),$1);}
       | action_seq BEGIN_ACT LPAREN ID RPAREN SEMI
                                   {$$ = CONS(ELEMENT("begin",SINGL(ELEMENT("state_id",SINGL(TEXT($4))))),$1);}
       | action_seq PUSH_ACT LPAREN ID RPAREN SEMI
                                   {$$ = CONS(ELEMENT("push",SINGL(ELEMENT("state_id",SINGL(TEXT($4))))),$1);}
       | action_seq POP_ACT SEMI
                                   {$$ = CONS(ELEMENT("pop",NIL),$1);}
       | action_seq INCR_ACT LPAREN ID RPAREN SEMI
                                   {$$ = CONS(ELEMENT1("incr",ELEMENT1("counter_id",TEXT($4))),$1);}
       | action_seq DECR_ACT LPAREN ID RPAREN SEMI
                                   {$$ = CONS(ELEMENT1("decr",ELEMENT1("counter_id",TEXT($4))),$1);}
       | action_seq TOKEN_ACT LPAREN ID RPAREN SEMI
                                   {$$ = CONS(ELEMENT("token",SINGL(ELEMENT("token_id",SINGL(TEXT($4))))),$1);}
       | action_seq TOKENTEXT_ACT LPAREN ID RPAREN SEMI
                                   {$$ = CONS(ELEMENT("tokentext",SINGL(ELEMENT("token_id",SINGL(TEXT($4))))),$1);}
       | action_seq START_ACT LPAREN ID RPAREN SEMI
                                   {$$ = CONS(ELEMENT("start",SINGL(ELEMENT("token_id",SINGL(TEXT($4))))),$1);}
       | action_seq END_ACT SEMI
                                   {$$ = CONS(ELEMENT("end",NIL),$1);}
       | action_seq CONTINUE_ACT SEMI
                                   {$$ = CONS(ELEMENT("continue",NIL),$1);}
       | action_seq ERROR_ACT LPAREN STRING RPAREN SEMI
                                   {$$ = CONS(ELEMENT("error",SINGL(TEXT($4))),$1);}
       | action_seq SKIP_ACT SEMI
                                   {$$ = CONS(ELEMENT("skip",NIL),$1);}
       | action_seq CUT_ACT LPAREN NUMBER RPAREN SEMI
            			   {$$ = CONS(ELEMENT1("cut",ELEMENT1("num",TEXT($4))),$1);}
       | action_seq TRIM_ACT LPAREN NUMBER RPAREN SEMI
            			   {$$ = CONS(ELEMENT1("trim",ELEMENT1("num",TEXT($4))),$1);}
       | action_seq ECHO_ACT SEMI
                                   {$$ = CONS(ELEMENT0("echo"),$1);}
       |                           {$$ = NIL;}
       ;
*/
%%
