stylesheet [version="1.0"];
output [method="text"];

include "regexp.xsl";

strip-space "*";

let newline = {"
"};

"/" -> {
apply-templates to "lex"
};

"lex" -> {
apply-templates to "declarations",
value-of "$newline",
"%%",
value-of "$newline",
apply-templates to "rules",
value-of "$newline",
"%%",
apply-templates to "definitions",
value-of "$newline"
};

"declarations" -> {
apply-templates to "option|inclusive_states|exclusive_states|code_declaration|abbreviation"
};

"inclusive_states" -> {
"%s",
for-each "state_id" {
" ",
value-of "."
},
value-of "$newline"
};

"exclusive_states" -> {
"%s",
for-each "state_id" {
" ",
value-of "."
},
value-of "$newline"
};

"code_declaration" -> {
"%{",
value-of "$newline",
value-of ".",
value-of "$newline",
"%}",
value-of "$newline"
};

"option" -> {
"%option ",
value-of ".",
value-of "$newline"
};

"abbreviation" -> {
value-of "id",
" ",
apply-templates to "regexp",
value-of "$newline"
};

"rules" -> {
apply-templates to "rule|scope"
};

"rule" -> {
apply-templates to "scon",
apply-templates to "regexp",
" ",
apply-templates to "action",
value-of "$newline"
};

"scon" -> {
"&lt;",
for-each "state_id" {
value-of ".",
if "position() != last()" {
","
}
},
"&gt;"
};

"any_state" -> {
"*"
};

"scope" -> {
apply-templates to "scon",
"{",
value-of "$newline",
apply-templates to "rule|scope",
"}",
value-of "$newline"
};

"action" -> {
apply-templates
};

"fallthru" -> {
"|"
};

"ccode" -> {
"{",
value-of ".",
"}"
};

