stylesheet [version="1.0"];
output [method="text"];

"dot" -> {
"."
};

"class" -> {
"[",
if "@negated = 'true'" {
"^"
},
apply-templates to "char|range|esc|expr",
"]"
};

"expr" -> {
"[:",
value-of "@val",
":]"
};

"star" -> {
apply-templates to "./*",
"*"
};

"plus" -> {
apply-templates to "./*",
"+"
};

"opt" -> {
apply-templates to "./*",
"?"
};

"pow" -> {
apply-templates to "*[1]",
"{",
apply-templates to "exact|atleast|between",
"}"
};

"followed_by" -> {
apply-templates to "*[1]",
"/",
apply-templates to "*[2]"
};

"ref" -> {
"{",
apply-templates to "./*",
"}"
};

"char" -> {
value-of "."
};

"quot" -> {
"&quot;",
value-of ".",
"&quot;"
};

"esc" -> {
value-of "."
};

"seq" -> {
"(",
apply-templates to "./*",
")"
};

"alt" -> {
"(",
for-each "./*" {
"(",
apply-templates to ".",
")",
if "position() != last()" {
"|"
}
},
")"
};

"bol" -> {
"^",
apply-templates
};

"eol" -> {
"$",
apply-templates
};

"eof" -> {
"&lt;&lt;EOF&gt;&gt;"
};

"exact" -> {
value-of "."
};

"atleast" -> {
value-of ".",
","
};

"between" -> {
value-of "num[1]",
",",
value-of "num[2]"
};

"num" -> {
value-of "."
};

"range" -> {
value-of "*[1]",
"-",
value-of "*[2]"
};

"id" -> {
value-of "."
};

"unparsed" -> {
value-of "."
};

